(let ((conv-procs (make-hash-table)))
  (defun get-conv-proc (name)
    (gethash name conv-procs))
  (defun set-conv-proc (name proc)
    (setf (gethash name conv-procs) proc)))

(defun apply-conv-proc (x)
  (let ((fn (get-conv-proc (car x))))
    (if (null fn)
	(progn
	 (format t "Nieznane sowo kluczowe ~s.~%" (car x))
	 nil)
      (funcall fn x))))

(defun apply-wrapped-conv-proc (x)
  (let ((res (apply-conv-proc x)))
    (if res
	(list res)
      nil)))

(defun spac (fntnm prenm postnm)
  ;; parameters being names of original font and (v)pl files
  (with-open-file (tfmin prenm)
    (with-open-file (tfmout postnm :direction :output)
      (print '(COMMENT This file was generated automatically) tfmout)
      (print '(COMMENT Do not edit it!) tfmout)
      (terpri tfmout)
      (princ `(VTITLE Spaced font ,fntnm version 0.6) tfmout)
      (terpri tfmout)
      (princ `(MAPFONT D 0 (FONTNAME ,fntnm)) tfmout)
      (let ((eof (list nil)))
	(loop
	 (let ((x (read tfmin nil eof nil)))
	   (if (eq x eof) (return))	   
	   (let ((res (apply-conv-proc x)))
	     (if res
		 (print res tfmout))))))
      (print '(BOUNDARYCHAR D 46) tfmout)
      (let ((-space-by (- space-by))
	    (-space-by/2 (/ (- space-by) 2)))
	(print `(LIGTABLE
		 (LABEL D 44)
		 (LIG D 44 D 255)
		 (LABEL D 46)
		 (LABEL D 48) (LABEL D 49) (LABEL D 50) (LABEL D 51)
		 (LABEL D 52) (LABEL D 53) (LABEL D 54) (LABEL D 55)
		 (LABEL D 56) (LABEL D 57)
		 (KRN D 48 R ,-space-by) (KRN D 49 R ,-space-by)
		 (KRN D 50 R ,-space-by) (KRN D 51 R ,-space-by)
		 (KRN D 52 R ,-space-by) (KRN D 53 R ,-space-by)
		 (KRN D 54 R ,-space-by) (KRN D 55 R ,-space-by)
		 (KRN D 56 R ,-space-by) (KRN D 57 R ,-space-by)
		 (SKIP D 8) (LABEL D 45) (LIG D 45 D 123)
		 (SKIP D 7) (LABEL D 123) (LIG D 45 D 124)
		 (SKIP D 6) (LABEL D 60) (LIG D 60 D 174)
		 (SKIP D 5) (LABEL D 62) (LIG D 62 D 175)
		 (SKIP D 4) (LABEL D 96) (LIG D 96 D 92)
		 (SKIP D 3) (LABEL D 39) (LIG D 39 D 34)
		 (SKIP D 2) (LABEL D 63) (LIG D 96 D 62)
		 (SKIP D 1) (LABEL D 33) (LIG D 96 D 60)
		 (LABEL D 0) (LABEL D 1) (LABEL D 2) (LABEL D 3)
		 (LABEL D 4) (LABEL D 5) (LABEL D 6) (LABEL D 7)
		 (LABEL D 8) (LABEL D 9) (LABEL D 10) (LABEL D 11)
		 (LABEL D 12) (LABEL D 13) (LABEL D 14) (LABEL D 15)
		 (LABEL D 16) (LABEL D 17) (LABEL D 18) (LABEL D 19)
		 (LABEL D 20) (LABEL D 21) (LABEL D 22) (LABEL D 23)
		 (LABEL D 24) (LABEL D 25) (LABEL D 26) (LABEL D 27)
		 (LABEL D 28) (LABEL D 29) (LABEL D 30) (LABEL D 31)
		 (LABEL D 32) (LABEL D 34) (LABEL D 35) (LABEL D 36)
		 (LABEL D 37) (LABEL D 38) (LABEL D 41) (LABEL D 42)
		 (LABEL D 43) (LABEL D 47) (LABEL D 58) (LABEL D 59)
		 (LABEL D 61) (LABEL D 64) (LABEL D 65) (LABEL D 66)
		 (LABEL D 67) (LABEL D 68) (LABEL D 69) (LABEL D 70)
		 (LABEL D 71) (LABEL D 72) (LABEL D 73) (LABEL D 74)
		 (LABEL D 75) (LABEL D 76) (LABEL D 77) (LABEL D 78)
		 (LABEL D 79) (LABEL D 80) (LABEL D 81) (LABEL D 82)
		 (LABEL D 83) (LABEL D 84) (LABEL D 85) (LABEL D 86)
		 (LABEL D 87) (LABEL D 88) (LABEL D 89) (LABEL D 90)
		 (LABEL D 92) (LABEL D 93) (LABEL D 94) (LABEL D 95)
		 (LABEL D 97) (LABEL D 98) (LABEL D 99) (LABEL D 100)
		 (LABEL D 101) (LABEL D 102) (LABEL D 103) (LABEL D 104)
		 (LABEL D 105) (LABEL D 106) (LABEL D 107) (LABEL D 108)
		 (LABEL D 109) (LABEL D 110) (LABEL D 111) (LABEL D 112)
		 (LABEL D 113) (LABEL D 114) (LABEL D 115) (LABEL D 116)
		 (LABEL D 117)
		 (LABEL D 118)
		 (LABEL D 119)
		 (LABEL D 120)
		 (LABEL D 121)
		 (LABEL D 122)
		 (LABEL D 124)
		 (LABEL D 125)
		 (LABEL D 126)
		 (LABEL D 127)
		 (LABEL D 129)
		 (LABEL D 130)
		 (LABEL D 134)
		 (LABEL D 138)
		 (LABEL D 139)
		 (LABEL D 145)
		 (LABEL D 153)
		 (LABEL D 155)
		 (LABEL D 161)
		 (LABEL D 162)
		 (LABEL D 166)
		 (LABEL D 170)
		 (LABEL D 171)
		 (LABEL D 174)
		 (LABEL D 175)
		 (LABEL D 177)
		 (LABEL D 185)
		 (LABEL D 187)
		 (LABEL D 211)
		 (LABEL D 243)
		 (LABEL D 255)
		 (KRN D 46 R ,-space-by)
		 (KRN D 44 R ,-space-by)
		 (KRN D 41 R ,-space-by)
		 (KRN D 93 R ,-space-by)
		 (KRN D 59 R ,-space-by/2)
		 (KRN D 58 R ,-space-by/2)
		 (KRN D 33 R ,-space-by/2)
		 (KRN D 63 R ,-space-by/2)
		 (STOP))
	       tfmout))
      t)))

(setq font-designsize 10.0)
(setq space-by 0.2)
(defvar *char-no*) ; numer biecego znaku UWAGA: zmienna dynamiczna!
(setq no-width-change  ; lista znakw, ktrych nie naley poszerza
      '(40 91))

(defun drop-it (x)
  nil)

(defun copy-it (x)
  x)

(defun conv-designsize (x)
  (setq font-designsize (caddr x))
  (setq space-by (/ (if (> font-designsize 9.0)
			2.0 1.0)
		    font-designsize))
  x)

(defun conv-fontdimen (x)
  (cons 'FONTDIMEN
	(mapcan #'apply-wrapped-conv-proc (cdr x))))

(defun change-width (x)
  (list (car x)
	(cadr x)
	(+ (caddr x) space-by)))

(defun maybe-change-width (x)
  (if (member *char-no* no-width-change)
      x
    (change-width x)))

(defun conv-char (x)
  (let ((*char-no* (caddr x))
	(args (cdddr x)))
    (nconc
     (list 'CHARACTER 'D *char-no*)
     (mapcan #'apply-wrapped-conv-proc args))))

(set-conv-proc 'COMMENT #'drop-it)
(set-conv-proc 'FAMILY #'copy-it)
(set-conv-proc 'FACE #'copy-it)
(set-conv-proc 'CODINGSCHEME #'copy-it)
(set-conv-proc 'DESIGNSIZE #'conv-designsize)
(set-conv-proc 'CHECKSUM #'drop-it)
(set-conv-proc 'FONTDIMEN #'conv-fontdimen)
(set-conv-proc 'SLANT #'copy-it)
(set-conv-proc 'SPACE #'change-width)
(set-conv-proc 'STRETCH #'copy-it)
(set-conv-proc 'SHRINK #'copy-it)
(set-conv-proc 'XHEIGHT #'copy-it)
(set-conv-proc 'QUAD #'copy-it)
(set-conv-proc 'EXTRASPACE #'copy-it)
(set-conv-proc 'CHARACTER #'conv-char)
(set-conv-proc 'CHARWD #'maybe-change-width)
(set-conv-proc 'CHARHT #'copy-it)
(set-conv-proc 'CHARDP #'copy-it)
(set-conv-proc 'CHARIC #'copy-it)
(set-conv-proc 'LIGTABLE #'drop-it)
